package AirplaneWithRadar;

import AirplaneWithRadar.MovementStrategy.Movement;
import AirplaneWithRadar.MovementStrategy.*;
import AirplaneWithRadar.PaintObjects.PaintAirplane;
import AirplaneWithRadar.PaintObjects.PaintAirplaneWithRadar;

import javax.swing.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.util.Random;
public class AirplaneWithRadarForm extends JFrame {
    private PaintAirplane PaintPlanes;
    private AbstractStrategy abstractStrategy;

    private void Draw()
    {
        if (PaintPlanes == null)
            return;

        BufferedImage bmp = new BufferedImage(
                AirplanePictureBox.getWidth(),
                AirplanePictureBox.getHeight(),
                BufferedImage.TYPE_INT_ARGB
        );
        Graphics2D g = bmp.createGraphics();
        PaintPlanes.DrawTransport(g);

        AirplanePictureBox.setIcon(new ImageIcon(bmp));
    }
    public AirplaneWithRadarForm()
    {
        InitializeComponent();
    }

    private void InitializeComponent()
    {
        AirplanePictureBox = new JLabel();
        ButtonCreateAirplane = new JButton();
        ButtonCreateAirplaneWithRadar = new JButton();
        ButtonRight = new JButton();
        ButtonDown = new JButton();
        ButtonLeft = new JButton();
        ButtonUp = new JButton();
        MovementStrategyComboBox = new JComboBox<String>();
        ButtonPerformMove = new JButton();
        AirplanePictureBox.setBounds(0, 0, 884, 461);
        //
        // ButtonCreateBomberBase
        //
        ButtonCreateAirplane.setName("ButtonCreateBomberBase");
        ButtonCreateAirplane.setBounds(12, 383, 260, 30);
        ButtonCreateAirplane.setText("Создать самолёт");
        ButtonCreateAirplane.setBackground(new Color(225, 225, 225));
        ButtonCreateAirplane.setFont(new Font("Segoe UI", Font.PLAIN, 11));
        ButtonCreateAirplane.setFocusable(false);
        ButtonCreateAirplane.addActionListener(e -> ButtonCreateAirplane_Click(e));
        //
        // CreateButton
        //
        ButtonCreateAirplaneWithRadar.setName("CreateButton");
        ButtonCreateAirplaneWithRadar.setBounds(12, 419, 260, 30);
        ButtonCreateAirplaneWithRadar.setText("Создать самолёт с радаром");
        ButtonCreateAirplaneWithRadar.setBackground(new Color(225, 225, 225));
        ButtonCreateAirplaneWithRadar.setFont(new Font("Segoe UI", Font.PLAIN, 11));
        ButtonCreateAirplaneWithRadar.setFocusable(false);
        ButtonCreateAirplaneWithRadar.addActionListener(e -> ButtonCreateAirplaneWithRadar_Click(e));
        //
        // ButtonRight
        //
        ButtonRight.setName("ButtonRight");
        ButtonRight.setBounds(842, 419, 30, 30);
        ButtonRight.setBackground(new Color(225, 225, 225));
        ButtonRight.setFont(new Font("Segoe UI", Font.PLAIN, 11));
        ButtonRight.setFocusable(false);
        ButtonRight.setIcon(new ImageIcon("src/AirplaneWithRadar/Resources/ArrowRight.png"));
        ButtonRight.addActionListener(e -> ButtonMove_Click(e));
        //
        // ButtonDown
        //
        ButtonDown.setName("ButtonDown");
        ButtonDown.setBounds(806, 419, 30, 30);
        ButtonDown.setBackground(new Color(225, 225, 225));
        ButtonDown.setFont(new Font("Segoe UI", Font.PLAIN, 11));
        ButtonDown.setFocusable(false);
        ButtonDown.setIcon(new ImageIcon("src/AirplaneWithRadar/Resources/ArrowDown.png"));
        ButtonDown.addActionListener(e -> ButtonMove_Click(e));
        //
        // ButtonLeft
        //
        ButtonLeft.setName("ButtonLeft");
        ButtonLeft.setBounds(770, 419, 30, 30);
        ButtonLeft.setBackground(new Color(225, 225, 225));
        ButtonLeft.setFont(new Font("Segoe UI", Font.PLAIN, 11));
        ButtonLeft.setFocusable(false);
        ButtonLeft.setIcon(new ImageIcon("src/AirplaneWithRadar/Resources/ArrowLeft.png"));
        ButtonLeft.addActionListener(e -> ButtonMove_Click(e));
        //
        // ButtonUp
        //
        ButtonUp.setName("ButtonUp");
        ButtonUp.setBounds(806, 383, 30, 30);
        ButtonUp.setBackground(new Color(225, 225, 225));
        ButtonUp.setFont(new Font("Segoe UI", Font.PLAIN, 11));
        ButtonUp.setFocusable(false);
        ButtonUp.setIcon(new ImageIcon("src/AirplaneWithRadar/Resources/ArrowUp.png"));
        ButtonUp.addActionListener(e -> ButtonMove_Click(e));
        //
        // ButtonPerformMove
        //
        ButtonPerformMove.setName("ButtonPerformMove");
        ButtonPerformMove.setBounds(706, 50, 166, 31);
        ButtonPerformMove.setText("Сделать шаг");
        ButtonPerformMove.setBackground(new Color(225, 225, 225));
        ButtonPerformMove.setFont(new Font("Segoe UI", Font.PLAIN, 11));
        ButtonPerformMove.setFocusable(false);
        ButtonPerformMove.addActionListener(e -> ButtonPerformStep_Click(e));
        //
        // MovementStrategyComboBox
        //
        MovementStrategyComboBox.setBounds(706, 12, 166, 23);
        MovementStrategyComboBox.addItem("Перемещать в центр");
        MovementStrategyComboBox.addItem("Перемещать вправо вниз");
        //
        // AirplaneWithRadarForm
        //
        setTitle("Самолет с радаром");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setSize(900, 500);
        setLayout(null);
        setLocationRelativeTo(null);
        setVisible(true);
        add(ButtonUp);
        add(ButtonLeft);
        add(ButtonDown);
        add(ButtonRight);
        add(ButtonCreateAirplaneWithRadar);
        add(ButtonCreateAirplane);
        add(ButtonPerformMove);
        add(MovementStrategyComboBox);
        add(AirplanePictureBox);
    }
    private JLabel AirplanePictureBox;
    private JButton ButtonCreateAirplane;
    private JButton ButtonCreateAirplaneWithRadar;
    private JButton ButtonRight;
    private JButton ButtonDown;
    private JButton ButtonLeft;
    private JButton ButtonUp;
    private JButton ButtonPerformMove;
    private JComboBox<String> MovementStrategyComboBox;

    private void ButtonMove_Click(ActionEvent e)
    {
        if (PaintPlanes == null)
            return;

        String ButtonName = ((JButton)e.getSource()).getName();

        switch (ButtonName)
        {
            case "ButtonUp":
                PaintPlanes.Move(Movement.Up);
                break;

            case "ButtonDown":
                PaintPlanes.Move(Movement.Down);
                break;

            case "ButtonLeft":
                PaintPlanes.Move(Movement.Left);
                break;

            case "ButtonRight":
                PaintPlanes.Move(Movement.Right);
                break;
        }

        Draw();
    }
    private void ButtonCreateAirplaneWithRadar_Click(ActionEvent e)
    {
        Random random = new Random();

        PaintPlanes = new PaintAirplaneWithRadar(
                random.nextInt(100, 300),
                random.nextInt(1000, 3000),
                new Color(random.nextInt(0, 256), random.nextInt(0, 256), random.nextInt(0, 256)),
                new Color(random.nextInt(0, 256), random.nextInt(0, 256), random.nextInt(0, 256)),
                true,
                true,
                AirplanePictureBox.getWidth(),
                AirplanePictureBox.getHeight()
        );
        PaintPlanes.SetPosition(random.nextInt(10, 60), random.nextInt(10, 60));

        MovementStrategyComboBox.setEnabled(true);
        Draw();
    }
    private void ButtonCreateAirplane_Click(ActionEvent e)
    {
        Random random = new Random();

        PaintPlanes = new PaintAirplane(
                random.nextInt(100, 300),
                random.nextInt(1000, 3000),
                new Color(random.nextInt(0, 256), random.nextInt(0, 256), random.nextInt(0, 256)),
                AirplanePictureBox.getWidth(),
                AirplanePictureBox.getHeight()
        );
        PaintPlanes.SetPosition(random.nextInt(10, 60), random.nextInt(10, 60));

        MovementStrategyComboBox.setEnabled(true);
        Draw();
    }
    private void ButtonPerformStep_Click(ActionEvent e)
    {
        if (PaintPlanes == null)
            return;

        if (MovementStrategyComboBox.isEnabled())
        {
            switch (MovementStrategyComboBox.getSelectedIndex())
            {
                case 0:
                    abstractStrategy = new MoveToCenter();
                    break;

                case 1:
                    abstractStrategy = new MoveToBorder();
                    break;

                default:
                    abstractStrategy = null;
            }

            if (abstractStrategy == null)
                return;

            abstractStrategy.SetData(
                    new PaintObjectAirplane(PaintPlanes),
                   AirplanePictureBox.getWidth(), AirplanePictureBox.getHeight()
            );

            MovementStrategyComboBox.setEnabled(false);
        }

        if (abstractStrategy == null)
            return;
        System.out.println(PaintPlanes.GetPosX());
        abstractStrategy.MakeStep();
        System.out.println(PaintPlanes.GetPosX());
        Draw();

        if (abstractStrategy.GetStatus() == Status.Finish)
        {
            MovementStrategyComboBox.setEnabled(true);
            abstractStrategy = null;
        }
    }
}
