package AirplaneWithRadar.MovementStrategy;

import AirplaneWithRadar.PaintObjects.PaintAirplane;

public class PaintObjectAirplane implements IMoveableObject {
    private final PaintAirplane paintAirplane;

    public PaintObjectAirplane(PaintAirplane paintAirplane) {
        this.paintAirplane = paintAirplane;
    }

    public ObjectParameters GetObjectPosition() {
        if (paintAirplane == null || paintAirplane.airplaneEntity == null) {
            return null;
        }
        return new ObjectParameters(paintAirplane.GetPosX(), paintAirplane.GetPosY(), paintAirplane.GetWidth(), paintAirplane.GetHeight());
    }

    public int GetStep() {
        if (paintAirplane == null || paintAirplane.airplaneEntity == null) return 0;
        return (int) (paintAirplane.airplaneEntity.Step);
    }

    public boolean CheckCanMove(Movement dir) {
        if (paintAirplane == null)
            return false;
        return paintAirplane.CanMove(dir);
    }

    public void MoveObject(Movement dir) {
        if (paintAirplane != null)
            paintAirplane.Move(dir);
    }
}
