package AirplaneWithRadar.PaintObjects;
import AirplaneWithRadar.Entities.AirplaneWithRadarEntity;

import java.awt.*;

public class PaintAirplaneWithRadar extends PaintAirplane {
    public PaintAirplaneWithRadar(int speed, double weight, Color mainColor, Color additColor, boolean radarOnBoard, boolean additFuelPod, int width, int height)
    {
        super(speed, weight, mainColor, width, height, 140, 60);
        if (planeWidth > width || planeHeight > height) { return; }

        if (airplaneEntity != null)
        {
            airplaneEntity = new AirplaneWithRadarEntity(speed, weight, mainColor, additColor, radarOnBoard, additFuelPod);
        }
    }
    @Override
    public void DrawTransport(Graphics g)
    {
        if (!(airplaneEntity instanceof AirplaneWithRadarEntity airplaneWithRadarEntity))
        {
            return;
        }
        super.DrawTransport(g);

        g.setColor(airplaneWithRadarEntity.getAdditColor());

        if (airplaneWithRadarEntity.RadarOnBoard) {
            g.setColor(airplaneWithRadarEntity.getAdditColor());
            g.drawLine(startPosX + planeWidth / 3, startPosY + planeHeight / 2, startPosX + planeWidth / 3, startPosY + planeHeight / 3);
            g.fillArc(startPosX + planeWidth / 4, startPosY + planeHeight / 10, planeWidth / 6, planeHeight / 4, -30, -180);
        }
        if (airplaneWithRadarEntity.AdditFuelPod)
        {
            g.setColor(airplaneWithRadarEntity.getAdditColor());
            g.fillRoundRect(startPosX, startPosY + planeHeight - 2*planeHeight / 5, planeWidth / 5, planeHeight / 6, 5, 5);
        }
    }
}
